# NOTE: Derived from blib/lib/GPS/Lowrance.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package GPS::Lowrance;

#line 660 "blib/lib/GPS/Lowrance.pm (autosplit into blib/lib/auto/GPS/Lowrance/set_plot_trail.al)"
sub set_plot_trail {
  require GPS::Lowrance::Trail;

  my $self = shift;
  assert( UNIVERSAL::isa( $self, __PACKAGE__ ) ), if DEBUG;

  if ($self->get_protocol_version < 1) {
    die "this method requires protocol version 2.0";
  }

  my %input    = @_;

  my $trail    = $input{plot_trail};
  assert( UNIVERSAL::isa( $trail, "GPS::Lowrance::Trail" ) ), if DEBUG;

  $input{plot_trail_number} = $trail->trail_num - 1;

  my @raw_trail = ();

  $trail->reset;
  while (my $point = $trail->next) {
    push @raw_trail, [ mercator_meters_to_degrees( @{$point}[0..1] ) ];
  }
  assert( scalar(@raw_trail) == $trail->size ), if DEBUG;

  $input{plot_trail} = \@raw_trail;

  return $self->set_plot_trail_mercator_meters( %input );
}

# end of GPS::Lowrance::set_plot_trail
1;
