# NOTE: Derived from blib/lib/GPS/Lowrance.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package GPS::Lowrance;

#line 579 "blib/lib/GPS/Lowrance.pm (autosplit into blib/lib/auto/GPS/Lowrance/set_plot_trail_mercator_meters.al)"
sub set_plot_trail_mercator_meters {
  my $self = shift;
  assert( UNIVERSAL::isa( $self, __PACKAGE__ ) ), if DEBUG;

  if ($self->get_protocol_version < 1) {
    die "this method requires protocol version 2.0";
  }

  my %input    = @_;
  my $callback = $input{callback} || sub { return; };
  assert( ref($callback) eq "CODE" ), if DEBUG;

  my $trail    = $input{plot_trail};
  assert( ref($trail) eq "ARRAY" ), if DEBUG;

  if ($self->get_num_of_plot_trails < $input{plot_trail_number}) {
    die "plot_trail_number too high";
  } elsif ($input{plot_trail_number} < 0) {
    die "invalid trail number";
  }

  my $count = scalar( @$trail );

  unless ($count) {
    die "cannot upload an empty trail";
  }


  my $point = shift @$trail;
  assert( defined $point ), if DEBUG;

  my ($lat_m, $lon_m) = @$point;

  my %args = (
    plot_trail_number => $trail->trail_num()-1,
    origin_x          => $lon_m,
    origin_y          => $lat_m,
    number_of_deltas  => --$count,
  );

  $self->set_plot_trail_origin( %args );

  # Parse::Binary::FixedFormat will complain if they are not defined

  foreach my $delta (1..40) {
    $args{"delta_x_$delta"} = 0;
    $args{"delta_y_$delta"} = 0;
  }

  while ($count) {
    &{$callback}( ($trail->size - $count) . "/" . $trail->size );

    my $expected = ($count > MAX_DELTAS) ? MAX_DELTAS : $count;

    $args{number_of_deltas} = $expected;
 
    $count -= $expected;
    
    my $delta = 1;
    while ($expected--) {
      $point = shift @$trail;
      assert( defined $point ), if DEBUG;

      my ($y, $x) = @$point;
      my $dy = $y - $lat_m;
      my $dx = $x - $lon_m;

      $args{"delta_x_$delta"} = $dx;
      $args{"delta_y_$delta"} = $dy;

      ($lat_m, $lon_m) = ($y, $x);

      $delta++;
    }
    $self->set_plot_trail_deltas( %args );
  }
  &{$callback}( ($trail->size - $count) . "/" . $trail->size );

  return;
}

# end of GPS::Lowrance::set_plot_trail_mercator_meters
1;
