# NOTE: Derived from blib/lib/GPS/Lowrance.pm.
# Changes made here will be lost when autosplit is run again.
# See AutoSplit.pm.
package GPS::Lowrance;

#line 528 "blib/lib/GPS/Lowrance.pm (autosplit into blib/lib/auto/GPS/Lowrance/set_waypoints.al)"
sub set_waypoints {
  require GPS::Lowrance::Waypoints;

  my $self = shift;
  assert( UNIVERSAL::isa( $self, __PACKAGE__ ) ), if DEBUG;

  my %input    = @_;

  my $callback = $input{callback} || sub { return; };
  assert( ref($callback) eq "CODE" ), if DEBUG;

  my $waypoints = $input{waypoints};
  assert( UNIVERSAL::isa( $waypoints, "GPS::Lowrance::Waypoints" ) ), if DEBUG;

  my $ignore    = $input{ignore_waypoint_numbers};

  if ($waypoints->size > $self->get_num_of_waypoints) {
    die "waypoints too large";
  }

  $waypoints->reset;

  my $num = 1;
  while (my $wpt = $waypoints->next) {

    &{$callback}( $num . '/' . $waypoints->size );

    my ($lat_m, $lon_m) = degrees_to_mercator_meters( $wpt->[0], $wpt->[1] );
      
    my $wpt_num = $wpt->[4];
    unless (!$ignore || (defined $wpt_num)) { $wpt_num = $num-1; }

    $self->set_a_waypoint(
      waypoint_number => $wpt_num,
      latitude        => $lat_m,
      longitude       => $lon_m,
      name            => $wpt->[2],
      date            => unix_to_gps_time($wpt->[3]),
      status          => 1,
      icon_symbol     => $wpt->[5]||0,
    );

    $num++;
  }

  &{$callback}( $num . '/' . $waypoints->size );

  return;
}

# end of GPS::Lowrance::set_waypoints
1;
